      Program OneCol2SMC

* Reformat into a smc file an ascii file with a single column of values
* (no time column), in which there are possible comments 
* preceeded by "!" or "|", followed by one header line, followed by the data
* in two columns: time, data

* Sample control file:
*!Control file for OneCol2SMC      ! first line
*! Revision of program involving a change in the control file on this date:
* 10/27/13
*!Name of summary file:
* OneCol2smc.sum
*! string to be added to input file name to create the output file name
* .smc
*!N lines to skip to get to data
* 1
*!Xfactr
* 1.0
*!SPS
* 200
*!Input file name ("stop" in any column to quit):
*p01_1.in
*p01_2.in
*p01_3.in
*p02_1.in
*p02_2.in
*p02_3.in
*STOP
  
* Dates: 06/30/06 - Written by D. Boore, patterned after asc2smc, and using
*                   parts of G. Wang's output_PSA_4events.f
*        10/17/07 - Transparent change to user needed because smcread can
*                   read two input formats
!        10/27/13 - Add control file change date, read number of first data line,
!                   string for output file name
 
      real time(100000), ts(100000)
      character f_ctl*120, f_sum*120, f_asc*120, f_smc*120, f_asc_4*4
      character char_head(11)*80, comments(200)*80, hdr_cmmnts(100)*79
      character headers_query*10, buf*80
      character precision*8
      character string4output*30

      integer int_head(48)
      real real_head(50)

      character date_ctl_correct*8, date_ctl_in*30

      logical f_ctl_exist

      do i = 2, 11
        char_head(i) = '*'
      end do

      int_null = -32768
      do i = 1, 48
        int_head(i) = int_null
      end do
*      int_head(13) = 0
*      int_head(14) = 0

      real_null = 1.7e+38
      do i = 1, 50
        real_head(i) = real_null
      end do

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file '//'
     :     (Enter = onecol2smc.ctl);'//
     :     ' ctl-brk to quit):'
        read(*, '(a)') f_ctl
        if (f_ctl(1:4) == '    ') f_ctl = 'onecol2smc.ctl'
        call trim_c(f_ctl, nc_f_ctl)
        inquire(file=f_ctl(1:nc_f_ctl), exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do
      
      call get_lun(nu_ctl)
      open(unit=nu_ctl, file=f_ctl(1:nc_f_ctl), status='unknown')

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      date_ctl_in = ' '
      read(nu_ctl,'(a)') date_ctl_in
      call trim_c(date_ctl_in,nc_date_ctl_in)
      
      date_ctl_correct = ' '
      date_ctl_correct = '10/27/13'
      call trim_c(date_ctl_correct,nc_date_ctl_correct)

      if (date_ctl_correct(1:nc_date_ctl_correct) .ne. 
     :    date_ctl_in(1:nc_date_ctl_in)) then
        write(*,'(a)') 
     :     ' The control file has the wrong date; update your '//
     :       'control file and rerun the program!'
        close(nu_ctl)
        stop
      end if
      
      call skipcmnt(nu_ctl,comments,nc_cmnts)
      f_sum = ' '
      read(nu_ctl,'(a)') f_sum
      call trim_c(f_sum, nc_f_sum)
      call get_lun(nu_sum)
      open(unit=nu_sum, file=f_sum(1:nc_f_sum), status='unknown')
      write(nu_sum,'(a)') '  Summary program for program OneCol2SMC'      

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      string4output = ' '
      read(nu_ctl,'(a)') string4output
      call trim_c(string4output, nc_string4output)
      write(nu_sum,'(a)') '  string4output: '//string4output      

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      read(nu_ctl,*) nlines2data
      nlines2skip = nlines2data-1
      write(nu_sum,'(1x,a,1x,i3)') ' nlines2skip = ', nlines2skip 


      call skipcmnt(nu_ctl,comments,nc_cmnts)
      read(nu_ctl,*) xfactr

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      read(nu_ctl,*) sps
      dt = 1.0/sps

      call skipcmnt(nu_ctl,comments,nc_cmnts)

1234  continue

      f_asc = ' '
      read(nu_ctl,'(a)') f_asc
      call trim_c(f_asc,nc_f_asc)
      f_asc_4 = ' '
      f_asc_4 = f_asc(1:4)
      call upstr(f_asc_4)
      if(f_asc_4 .eq. 'STOP') go to 4321
      write(nu_sum,'(2a)') '  Processing file: ', f_asc(1:nc_f_asc)

      call get_lun(nu_asc)
      open(unit=nu_asc, file=f_asc(1:nc_f_asc), status='unknown')
      
      if (nlines2skip > 0 ) then
        call skip(nu_asc,nlines2skip)
      end if

      n_ts=0
100   continue
        buf = ' '
        read(nu_asc,'(a)',end=999) buf
        call trim_c(buf,nb)
        if(buf(1:nb).EQ.'NaN')then
         go to 100
        else
         n_ts = n_ts + 1
         time(n_ts) = float(n_ts-1)/sps
         read(buf(1:nb),*) ts(n_ts)
        end if
        go to 100
999    continue
        
 
* Scale the time series:
      do i = 1, n_ts
        ts(i) = xfactr * ts(i)
      end do

      write(nu_sum,'(a,1x,i6,1x,f7.2)') '    n_ts, sps = ', n_ts, sps

      int_head(17) = n_ts
      
      real_head(2) = sps

      call skipcmnt(nu_asc, hdr_cmmnts, n_hdr_cmmnts)

      ncomments = 0
      ncomments = ncomments + 1
      comments(ncomments) = '|'
      do i = 1, n_hdr_cmmnts
        ncomments = ncomments + 1
        comments(ncomments) = '|'//hdr_cmmnts(i)
      end do
      ncomments = ncomments + 1
      comments(ncomments) = '|'
      ncomments = ncomments + 1
      comments(ncomments) = '| File '//f_asc(1:nc_f_asc)//
     : ' reformatted by program OneCol2SMC'
      ncomments = ncomments + 1
      comments(ncomments) = '| Data values scaled by the factor '
      call trim_c(comments(ncomments), nc_c)
      write(comments(ncomments)(nc_c+1:nc_c+11),'(0p,1x,e10.3)')
     :  xfactr
      ncomments = ncomments + 1
      comments(ncomments) = '|'

      int_head(16) = ncomments

      f_smc = ' '
      f_smc = f_asc(1:nc_f_asc)//string4output(1:nc_string4output)
      call trim_c(f_smc,nc_f_smc)

      write(*,'(a)') ' Writing file '//f_smc(1:nc_f_smc)

      precision = ' '
      if (int_head(47) .eq. 8) then
        precision = 'HIGH'
      else
        precision = 'STANDARD'
      end if
      
      call smcwrite(f_smc, precision,
     :              ts, char_head, 0, 
     :              int_head, real_head, comments)
     
      close(nu_asc)

      go to 1234

4321  continue

      close(nu_ctl)
      close(nu_sum)

      stop
      end

      include '\forprogs\skip.for'
      include '\forprogs\smcwrite.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\upstr.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\mnmaxidx.for'
      include '\forprogs\skipcmnt.for'
      include '\forprogs\distaz.for'
